"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const selectFormat = (format, tracks) => {
    // Format selection
    let selectedVideoTrack, selectedAudioTrack;
    if (!format) {
        selectedVideoTrack = tracks.videoTracks[0];
        selectedAudioTrack = tracks.audioTracks[0];
    }
    else {
        const formatArr = format.split("+").map((f) => parseInt(f));
        selectedVideoTrack = tracks.videoTracks.find((track) => formatArr.includes(track.id));
        selectedAudioTrack = tracks.audioTracks.find((track) => formatArr.includes(track.id));
        // If not selected, fallback to the best
        if (!selectedVideoTrack) {
            selectedVideoTrack = tracks.videoTracks[0];
        }
        if (!selectedAudioTrack) {
            selectedAudioTrack = tracks.audioTracks[0];
        }
    }
    return {
        selectedVideoTrack,
        selectedAudioTrack,
    };
};
exports.default = selectFormat;
//# sourceMappingURL=select_format.js.map